<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN"
               "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html xmlns="http://www.w3.org/1999/xhtml"
lang="en" xml:lang="en">
<head>
<title>RPy demo in L3</title>
<meta http-equiv="Content-Type" content="text/html;charset=iso-8859-1"/>
<meta name="generator" content="Org-mode"/>
<meta name="generated" content="2008/04/02 15:04:13"/>
<meta name="author" content="Michael Hohn"/>
<link rel=stylesheet href="l3style.css" type="text/css" media="screen">
<link rel=stylesheet href="l3style-print.css" type="text/css" media="print">
</head><body>
<h1 class="title">RPy demo in L3</h1>



<div id="toc">
<a href="index.html">Up</a>
<div id="table-of-contents">
<h2>Table of Contents</h2>
<ul>
<li><a href="#sec-1">1 Start with the script</a></li>
<li><a href="#sec-2">2 Move the script into the worksheet</a></li>
<li><a href="#sec-3">3 Examine key-value data</a></li>
<li><a href="#sec-4">4 View some graphs </a></li>
</ul>
</div>

</div> 

<div id="content">

<p>
This is the RPy demo from <a href="http://rpy.sourceforge.net/rpy_demo.html">rpy.sf.net</a> adjusted for the L3 worksheet
interface<sup><a class="footref" name="fnr.1" href="#fn.1">1</a></sup>.  In particular, all <code>print</code> statements displaying
data are removed (they are not needed with interactive data
viewing), and the <code>print</code> commands providing header information are
turned into outline headers (when viewing data next to the source,
there is no need to replicate this information).
</p>
<p>

<hr/>
</p>

<div class="outline-2">
<h2 id="sec-1">1 Start with the script</h2>

<p>Starting point for this demo is the script, produced as usual via a
text editor; it contains far too much detail to make graphical editing
practical: 
</p>
<p>
<pre>
if ("outline", "External code"):
    inline '''if 1:
    from rpy import *
    d = r.capabilities()
    if d['png']:
        device = r.png 
        ext='png'
    else:
        device = r.postscript
        ext='ps'
    '''
 
if ("outline", "Parameters"):
    img_width = 400
    img_height = 300
    ed = r.faithful["eruptions"] 
 
if ("outline", "Summary of Old Faithful eruption duration data"):
    r.sink('_summary-%d.txt' % new_id())
    r.print_(r.summary(ed))
    r.sink()
 
if ("outline", "Stem-and-leaf plot of Old Faithful eruption duration data"):
    r.sink('_stemleaf-%d.txt' % new_id())
    r.stem(ed)
    r.sink()
 
if ("outline", "Old Faithful eruptions"):
    file = 'faithful_histogram-%d.%s' % (new_id(), ext)
    device(file, width=img_width, height=img_height)
    r.hist(ed,r.seq(1.6, 5.2, 0.2), prob=1,col="lightgreen",
           main="Old Faithful eruptions",
           xlab="Eruption duration (seconds)")
    r.lines(r.density(ed,bw=0.1),col="orange") 
    r.rug(ed)
    r.dev_off()
 
if ("outline", "Old Faithful eruptions longer than 3 seconds"):
    title = "Empirical cumulative distribution function of \nOld Faithful eruptions longer than 3 seconds"  
    long_ed = filter(lambda x: x &gt; 3, ed)
    file = 'faithful_ecdf-%d.%s' % (new_id(), ext)
    device(file, width=img_width,height=img_height)
    r.library('stepfun')
    r.plot(r.ecdf(long_ed), do_points=0, verticals=1, main = title) 
    x = r.seq(3,5.4,0.01)
    r.lines(r.seq(3,5.4,0.01),
            r.pnorm(r.seq(3,5.4,0.01),
                    mean=r.mean(long_ed), sd=r.sqrt(r.var(long_ed))),
            lty=3, lwd=2, col="red")
    r.dev_off()
 
if ("outline", "Quantile plots"):
    file = 'faithful_qq-%d.%s' % (new_id(), ext)
    device(file, width=img_width, height=img_height)
    r.par(pty="s")
    r.qqnorm(long_ed, col="blue")
    r.qqline(long_ed, col="red")
    r.dev_off()
 
if ("outline", "Shapiro-Wilks normality test of Old Faithful eruptions longer than 3 seconds"):
    r.library('ctest')
    sw = r.shapiro_test(long_ed)
 
if ("outline", "One-sample Kolmogorov-Smirnov test of Old Faithful eruptions longer than 3 seconds"):
    ks = r.ks_test(long_ed,"pnorm", mean=r.mean(long_ed),
                   sd=r.sqrt(r.var(long_ed)))
</pre>
</p>
</div>

<div class="outline-2">
<h2 id="sec-2">2 Move the script into the worksheet</h2>

<p>This could be loaded all at once but for exploration working with one
section at a time is better.  Using <code>edit &gt; L3 terminal console</code>, get
a console on the terminal RPy was started from.  There are now three
windows, the source code, the terminal, and the gui:
</p>
<p>
<a href="images/rpydemo-1.png"><img src="images/rpydemo-1-sm.png"/></a>
</p>
<p>
The gui accumulates the expressions entered into the terminal.  After
copying the first three outlines, this is 
</p>
<p>
<a href="images/rpydemo-2.png"><img src="images/rpydemo-2-sm.png"/></a>
</p>
</div>

<div class="outline-2">
<h2 id="sec-3">3 Examine key-value data</h2>

<p>By expanding the outline, we see the three code lines; the <code>r.sink</code>
command put plain text output into a file (which we can inspect if
desired).  But to just view the results, a simple menu selection is
enough:
</p>
<p>
<a href="images/rpydemo-3.png"><img src="images/rpydemo-3-sm.png"/></a>
</p>
<p>
This brings the script and its output together in one place and there is
no redundant information &ndash; the header describes what we're looking
at, without additional <code>print</code> statements to provide the same
information in the output.
</p>
</div>

<div class="outline-2">
<h2 id="sec-4">4 View some graphs </h2>

<p>The graphical abilities of R can be used similarly.  Running the whole
script first, we can selectively view plots.  In the following image,
we see the script section setting plot parameters on the left, with
the (generated) file name and contents on the right:
</p>
<p>
<a href="images/rpydemo-4.png"><img src="images/rpydemo-4-sm.png"/></a>
</p>
<p>
Again, the script and the output are together, so we don't have to
manually make the association between several graphs on one side and
multiple script fragments on the other.
</p>



-----------

<p>
Footnotes: 
</p>
<p class="footnote"><sup><a class="footnum" name="fn.1" href="#fnr.1">1</a></sup>  This demo requires R and RPy to be installed.  Your system's
package handler may provide these, e.g.
<pre>
   apt-get install python-rpy
</pre>
on Ubuntu or Debian GNU/Linux or
<pre>
   yum install rpy
</pre>
on Fedora 6 or newer systems.
The <a href="index.html#alternate-installation">self-contained L3 installer</a> also
has rules for installing these locally.  The commands
<pre>
   cd &lt;path to installer&gt;/bindings/rpy
   make install
</pre>
will download, compile and "install" rpy and dependencies.  Note that
a FORTRAN compiler is required.

<p>

<hr/>
</p>



</div> 
</div>
<div id="postamble"><p class="author"> Author: Michael Hohn
<a href="mailto:mhhohn@users.sourceforge.net">&lt;mhhohn@users.sourceforge.net&gt;</a>
</p>
<p class="date"> Date: 2008/04/02 15:04:13</p>
</div></body>
</html>
